
{ Unit for Double Buffering work with 13h VGA mode }
{ Code by VanDamM / [WRC]                          }

Unit V_Sharp;
interface
Type
 DoubleBuffer = array[0..319, 0..199] of byte;
 DBufferPtr   = ^DoubleBuffer;

Var
 DBuffer      : DBufferPtr;
 Screen_13h   : DBufferPtr;
 BackGround   : DBufferPtr;
 SBuffer      : DBufferPtr;

Procedure init13h;
Procedure kill13h;

Procedure initVariables;
Procedure killVariables;

Procedure PutPixel(WhereDraw : DBufferPtr; X, Y : integer; Color : byte);
Function  GetPixel(WhereDraw : DBufferPtr; X, Y : integer) : byte;

Procedure WaitRetrace;


implementation

Procedure init13h; Assembler;
Asm
 mov ax, 0013h
 int 10h
End;

Procedure kill13h; Assembler;
Asm
 mov ax, 0003h
 int 10h
End;

Procedure initVariables;
Begin
 New(DBuffer);
 New(BackGround);
 New(SBuffer);
End;

Procedure killVariables;
Begin
 Dispose(DBuffer);
 Dispose(BackGround);
 Dispose(SBuffer);
End;

Procedure PutPixel(WhereDraw : DBufferPtr; X, Y : integer; Color : byte);
Var
 SOffset, R : longint;
Begin
 R:=Y; SOffset:= R shl 8 + R shl 6 + X;
 mem[Seg(WhereDraw^):SOffset]:=Color;
End;

Function  GetPixel(WhereDraw : DBufferPtr; X, Y : integer) : byte;
Var
 SOffset, R : longint;
Begin
 R:=Y; SOffset:= R shl 8 + R shl 6 + X;
 GetPixel:=mem[Seg(WhereDraw^):SOffset];
End;

Procedure WaitRetrace;
Begin
 Repeat Until ((Port[$3DA] AND 8) <> 0);
End;

Begin
 Screen_13h := Ptr($A000,$0000);
End.