{$M 16384,0,256000}
Program WRC_intro;
Uses Dos, Crt, V_Sharp, P_Sharp, Mpalette, Music, TPac;

{
  Transparent Motion Blured Bitmap Sinus Scrolling combo with wireframe tube

  // code by VanDamM // Muzak by Vitalya M // [WRC'99] //

  TED FONT technology               by Paradise '94
  GDM music player engine           by Alex Chalfin '94-95
  Resource file manager TPAC v1.7   by Tim Gordon '97

  Magic Palettes unit               by VDM '97
  Double Buffer unit                by VDM '98-99
  PCX loader for double buffer unit by VDM '97-99
  Transparent Motion Blur code      by VDM '99
  Crypt modification for TPAC v1.7  by VDM '99

}

Const
 SizeY          = 52;
 Size           = 10955; { TED Font size }
 Amount         = 24;    { number of circles }

Var
 BitMap         : Array [0..59*320-1] Of Byte;
 Palette        : Array [0..255,1..3] Of Byte;
 Chars          : Array [' '..']'] Of Pointer;
 CharsData      : Array [' '..']',1..3] Of Byte;
 F              : File;
 B,Row,Nr,Idx   : Byte;
 I, J           : Integer;
 Ch, K          : Char;
 SText          : String;
 S1, S2         : Array [0..255] Of Byte;
 CPos           : Array [0..319] Of Word;
 Fseg, Fofs     : Word;
 P1, P2         : PaletteArray;

 Circles        : Array[1..360, 1..Amount] of word;
 Xsinus,
 Ysinus         : Array[1..720] of integer;

 SinPtr,
 Xx, Yy,
 x, y, a        : integer;
 r              : real;

 Blur_Const     : integer;
 Contrast       : integer;

 DelF           : file;


{$F+}
{$L FONT.OBJ}
Procedure FDATA; External;
{$F-}


{ Calculate position with sin-table }
Procedure CalcCPos;
Var I: Integer;
Begin
 For I:=0 To 319 Do CPos[I]:=320*(S1[(I+Idx) mod 230]+S2[I mod 115])+I+32000;
End;

{ too easy asm code ;) }
Procedure Transparent_Motion_Blur(Step : Byte);
Var DBufSeg: word;
    BackSeg: word;
    ScreenSeg: word;
    SecondSeg: word;
Begin

 DBufSeg:=Seg(DBuffer^);
 BackSeg:=Seg(BackGround^);
 ScreenSeg:=Seg(Screen_13h^);
 SecondSeg:=Seg(SBuffer^);

asm

  mov di, 64000
  mov es, SecondSeg
  push ds
  mov ds, DBufSeg
  xor cx, cx

@001:

  mov ax, [di]
  mov dx, es:[di]
  mov bx, dx

  and al, al
  jz  @002
  add bl, al
  rcr bl, 1
  mov [di], cl

@002:

  sub bl, Step
  jnc @003
  xor bl, bl

@003:

  and ah, ah
  jz  @004
  add bh, ah
  rcr bh, 1
  mov [di+1], cl

@004:

  sub bh, Step
  jnc @005
  xor bh, bh

@005:

  mov es:[di], bx

  push ds
  push es
  mov ds, BackSeg
  mov es, ScreenSeg
  add bx, ds:[di]
  mov es:[di], bx
  pop es
  pop ds

  sub di, 2
  jnc @001
  pop ds

end;
End;

{ Calculate sin-table }
Procedure CalcSiN;
Var I: Integer;
Begin
 For I:=0 To 230 Do S1[I]:=Round(sin(2*I*Pi/230)*20)+20;
 For I:=0 To 115 Do S2[I]:=Round(sin(2*I*Pi/115)*3)+3;
End;

{ Put Bitmap in Secondary Buffer :) }
Procedure DrawBitMap;
Var SBufSeg: word;
Begin

 SBufSeg:=Seg(SBuffer^);

 asm
  mov es, SBufSeg
  xor cx, cx

@001:

  xor dx, dx
  mov si, cx
  add si, cx
  mov di, word ptr CPos[si]
  mov si, cx

@002:

  mov al, byte ptr BitMap[si]
  cmp al, 2
  jne @999
  mov al, 130
  mov [es:di], al

@999:

  add si, 320
  add di, 320
  inc dl
  cmp dl, SizeY
  jne @002
  inc cx
  cmp cx, 319
  jne @001
 End;
End;

{ Scroll Bitmap in yer array }
Procedure ScrollBitMap(Var Map); Assembler;
Asm
 lds si, Map
 les di, Map
 inc si
 inc si
 mov cx, 9600
 rep movsw
End;

{ Load .TED File To Memory }{ Proc by Paradise'94 - cool man huh? :))) }
Procedure LoadTED;
Var Tx, Ty : Byte;
    Ch     : Char;
    Segm,
    Ofst,
    Eofs   : Word;
Begin
 Segm:=Seg(Fdata);
 Ofst:=Ofs(Fdata);
 Eofs:=Ofst+Size;
 Inc(Ofst,20); { Skip File Header }
 While Not(Ofst=Eofs) Do
 Begin
  Move(Mem[Segm:Ofst],Ch,1); Inc(Ofst);
  Move(Mem[Segm:Ofst],Tx,1); Inc(Ofst);
  Move(Mem[Segm:Ofst],Ty,1); Inc(Ofst);
  Getmem(Chars[Ch],Tx*Ty);
  CharsData[Ch,1]:=Tx; CharsData[Ch,2]:=Ty; CharsData[Ch,3]:=1;
  Move(Mem[Segm:Ofst],Chars[Ch]^,Tx*Ty); Inc(Ofst,Tx*Ty);
 End;
 If CharsData[' ',3]<>1 Then { If Not Space " " Then Create It }
 Begin
  Tx:=CharsData['A',1];
  Ty:=CharsData['A',2];
  Getmem(Chars[' '],Tx*Ty);
  Fillchar(Chars[' ']^,Tx*Ty,0);
  CharsData[' ',3]:=1;
  CharsData[' ',1]:=Tx;
  CharsData[' ',2]:=Ty;
 End;
End;

{ Deallocate Font Memory }{ Proc by Paradise'94 - cool man huh? :))) }
Procedure DoneTED;
Var Ch: Char;
Begin
 For Ch:=' ' To ']' Do
 Begin
  If CharsData[Ch,3]=1 Then
  Begin
   FreeMem(Chars[Ch], CharsData[Ch, 1] * CharsData[Ch, 2]);
   CharsData[Ch,3]:=0;
  End;
 End;
End;

{ Sinucate Bitmap :)))) somebullshit }
Procedure NewRow(Ch: Char; Ro: Byte; Pos: Integer);
Var Tx, Ty, IC : Integer;
Begin
 If CharsData[Ch, 3] <> 1 Then Exit;
 IC:=(60-CharsData[Ch, 2]) Div 2;

 For Ty:=0 To 59 Do Bitmap[Ty*320+Pos]:=0;

 If Ro = CharsData[Ch, 1] + 1 Then
  For Ty:=1 To CharsData[Ch, 2] Do Bitmap[(Ty+IC)*320+Pos]:=0
 Else
  For Ty:=1 To CharsData[Ch, 2] Do
   Bitmap[(Ty+IC)*320+Pos]:=Mem[Seg(Chars[Ch]^):Ofs(Chars[Ch]^)+
                            (Ty-1) * CharsData[Ch, 1]+Ro-1];
End;

{ Update proc }
Procedure Update;
Begin
 Inc(Row);
 If Row > Charsdata[SText[Nr],1]+1 Then
  Begin
   Row:=1; Inc(Nr);
   If Nr > Length(SText) Then Nr:=1;
  End;
End;

{ Cuted from CUZ_CRT.PAS :) }
function StrToInt(S: string): longint;
var
 Code : integer;
 i : longint;
begin
 Val(S, i, Code);
 StrToInt := i;
end;


Begin { Main(); }

 WriteLn;
 WriteLn(' - Transparent motion blur bitmap sinus scroll & wormhole - // [WRC''99] - ');
 WriteLn;


 if ParamCount < 2 then
  begin
   Blur_Const:=6;
   Contrast  :=30;
  end
 else
  begin
   Blur_Const:=StrToInt(ParamStr(1));
   Contrast  :=StrToInt(ParamStr(2));
  end;

 For i:=1 to 10 do ExtractFile[i] := '';

 ExtractFile[1] := 'sbpro.mse';    ExtractFiles('wrc_blur.pak');
 ExtractFile[1] := '3tran.gdm';      ExtractFiles('wrc_blur.pak');
 InitializeMusic;
 Assign(DelF, 'sbpro.mse'); Erase(DelF);
 Assign(DelF, '3tran.gdm'); Erase(DelF);

 CalcSiN;
 Init13h;
 initVariables;
 LoadTED;

 SText:='HELLO, DEMO WORLD! WILD REINDEER CREW IS GLAD TO WELCOME '+
        'YOU. GREETZ GO TO [FINGERZ TEAM]. SPAWN CREW. EX-LYNX MEMBERS '+
        'AND OF COURSE TO ALL COMPUTER UNDERGROUND...                                    ';

 Nr:=1; Row:=1; Idx:=0;

 FillChar(SBuffer^, SizeOf(DBuffer^), 0);
 FillChar(DBuffer^, SizeOf(DBuffer^), 0);

 ExtractFile[1] := 'wrc_blur.pcx'; ExtractFiles('wrc_blur.pak');
 ReadPCXfile(BackGround, 'wrc_blur.pcx', 0, 0);
 Assign(DelF, 'wrc_blur.pcx'); Erase(DelF);

 for i:=0 to 319 do
  for j:=0 to 199 do
   PutPixel(BackGround, i, j, GetPixel(BackGround, i, j) + Contrast);

  For A:=1 To Amount Do
   Begin
    R:=0;
    For X:=1 To 360 Do
     Begin
      R:=R+(0.0175)*4;
      Circles[X,A]:=Round(sin(R)*(5+(A shl 2)))+(5+(A shl 2));
     End;
   End;

  R:=0;
  For X:=1 To 720 Do
   Begin
    R:=R+0.0175;
    Xsinus[X]:=Round(sin(R)*140)+140;
    Ysinus[X]:=Round(cos(R)*90)+90;
   End;
  SinPtr:=0;

 For i:=0 to 255 do
  Begin
   P1[i].R:=63;
   P1[i].G:=63;
   P1[i].B:=63;
  End;

 FadeFromPaletteToPalette(PaletteUsr, P1);
 Screen_13h^:=BackGround^;
 FadeFromPaletteToPalette(P1, PaletteUsr);

 BeginMusic;

 Repeat

   ScrollBitMap(Bitmap);
   Update; NewRow(SText[Nr], Row, 318);
   Update; NewRow(SText[Nr], Row, 319);
   CalcCPos;
   WaitRetrace;
   DrawBitmap;

   if SinPtr > 358 then SinPtr:=0;
   inc(SinPtr, 2);

   For A:=1 To Amount Do
    For X:=1 To 90 Do
     Begin
      Xx:=(Circles[X,A]+Xsinus[(A shl 3)+SinPtr])-A*4;
      Yy:=(Circles[X+23,A]+Ysinus[SinPtr+90+(A shl 2)])-(A*4);

      If ((Xx>0) And (Xx<319)) Then
       If ((Yy>0) And (Yy<199)) Then
        PutPixel(DBuffer, Xx, Yy, A+80);
     End;

   WaitRetrace;
   Transparent_Motion_Blur(Blur_Const);
   Idx:=4 + (Idx Mod 230);

 Until Keypressed;

 CloseMusic;
 FadeFromPaletteToPalette(PaletteUsr, P1);
 FadeFromPaletteToPalette(P1, PaletteTmp);

 DoneTED;
 killVariables;
 kill13h;
 While KeyPressed do ReadKey;

 WriteLn(' -- Code by VanDamM // Muzak by Vitalya M // [WRC''1999] -- ');

End.
